//
//  engines.c
//  cubesql
//
//  Created by Marco Bambini on 11/02/15.
//  Copyright (c) 2015 CreoLabs. All rights reserved.
//

#include "engines.h"

static extern_resolver *gresolver;

CUBESQL_API int cubesql_engine_internal_init (extern_resolver *resolver) {
	gresolver = resolver;
	return CUBESQL_ENGINE_VERSION;
}

// client
void *client_getdb (void *client) {
	return gresolver->client_getdb(client);
}

void client_set_error (void *client, int errcode, char *message) {
	gresolver->client_seterror(client, errcode, message);
}

void client_set_affectedrows (void *client, cubesql_int64 nrows) {
	gresolver->client_set_affectedrows(client, nrows);
}

void client_set_lastrowid (void *client, cubesql_int64 rowid) {
	gresolver->client_set_lastrowid(client, rowid);
}

int client_senderror (void *client) {
	return gresolver->client_senderror(client);
}

int client_sendcursor (void *client, void *cursor) {
	return gresolver->client_send_cursor(client, cursor);
}

// cursor
void *cursor_allocate (int nrows, int ncols) {
	return gresolver->cursor_allocate(nrows, ncols);
}

void cursor_free (void *cursor) {
	gresolver->cursor_free(cursor);
}

int cursor_copy_char (void *cursor, char *data, int len) {
	return gresolver->cursor_copy_char(cursor, data, len);
}

int cursor_copy_int (void *cursor, int value) {
	return gresolver->cursor_copy_int(cursor, value);
}

void cursor_set_nrows (void *cursor, int nrows) {
	return gresolver->cursor_set_nrows(cursor, nrows);
}

// cubesql
void cubesql_getpath (char *path, int type) {
	gresolver->cubesql_getpath(path, type);
}

void cubesql_pathcombine (char *path, const char *path1, const char *path2) {
	gresolver->cubesql_pathcombine(path, path1, path2);
}
